<?php
/*=====================================================================================================================================*/
/* Ce fichier fait partie de "Yexplorer 1.0", un explorateur en php par Yoann Lemain.                                                                                                                                   */
/* Yexplorer est sous la license Creative Commons "Paternit - Pas d'Utilisation Commerciale - Partage des Conditions Initiales  l'Identique 2.0 France".          */
/* Pour plus de dtails, voir : http://creativecommons.org/licenses/by-nc-sa/2.0/fr/.                                                                                                                            */
/*                                                                                                                                                                                                                                                                          */
/* This file is part of "Yexplorer", a php explorer by Yoaan Lemain.                                                                                                                                                           */
/* Yexplorer is under the "Attribution-NonCommercial-ShareAlike 2.0 France" Creative Commons license.                                                                                          */
/* For further details see : http://creativecommons.org/licenses/by-nc-sa/2.0/fr/deed.en_US .                                                                                                          */
/*=====================================================================================================================================*/

function listing($directory, $treepath, $filespath){

	if( @$_GET['refresh'] || !isset($_SESSION['tree']) ){
		$_SESSION['tree']=null;
		getTree($_SESSION['tree'], $directory);
	}

	if( isset($_SESSION['tree']) ) {
		$opendirs=null;

		$temp = $tok = strtok($treepath,'/');
		while($tok !== false){
			$opendirs[] = $temp;
			$tok = strtok('/');
			$temp = $temp.'/'.$tok;
		}

		printTree($filespath, $_SESSION['tree'], $opendirs, $directory );
	}

}

function getTree(&$tree, $root, $dir=null){
	$dir_handle = @opendir($root.'/'.$dir);
	if(isset($dir_handle)) {
		while(false !== ($subdir = readdir($dir_handle))){
			if( $subdir !='.' && $subdir !='..' && is_dir($root.'/'.$dir.'/'.$subdir) ) {
				if($dir){
					$tree[$dir.'/'.$subdir] = $dir;
					getTree($tree, $root, $dir.'/'.$subdir);
				}else{
					$tree[$subdir] = $dir;
					getTree($tree, $root, $subdir);
				}
			}
		}
		closedir($dir_handle);
	}
	else
		echo 'Unable to open "'.$dir.'"';
}

function printTree($filespath, &$tree, $opendirs, $root, $dir=null ){

	$subdirs = array_keys($tree, $dir);
	
	foreach($subdirs as $subdir){

		if($opendirs)
			$open = in_array($subdir, $opendirs);
		else
			$open=false;

		if($open) {
			$link=$tree[$subdir];
			if($link)
				$link='?treepath='.$link;
		}
		else
			$link='?treepath='.$subdir;
			
		if($filespath)
			if($link)
				$link.='&amp;filespath='.$filespath;
			else
				$link = '?filespath='.$filespath;

		if( in_array($subdir, $tree) ){
			echo '<div class="folder">';
			echo '<a href="index.php'.$link.'" >';
			if($open){
				echo '<img src="style/collapse.png" alt="-" title="-" /></a>';
			}
			else {
				echo '<img src="style/expand.png" alt="+" title="+" /></a>';
			}
		}
		else
			echo '<div class="shiftedfolder">';

		echo '<a href="index.php?treepath='.$subdir.'&amp;filespath='.$subdir.'" >';
		echo ' <img src="style/';
		if ($open)
			echo 'folder_open.png" alt="~"';
		else
			echo 'folder_closed.png" alt="-"';
		echo ' title="Dossier"/>';

		$dirname = substr(strrchr($subdir, '/'), 1);
		if(!$dirname)
			$dirname = $subdir;

		echo '&nbsp;'.$dirname;
		echo '</a>';

		if($open){
			echo '<div class="subtree">';
				printTree($filespath, $tree, $opendirs, $root, $subdir);
			echo '</div>';
		}
		echo '</div>';
	}

}

#=========================================================================================

function printFiles($root, $dir){

	global $docs_dir;

	if( $dir_handle = @opendir($root.'/'.$dir) ) {
		if($dir)
			$dir.='/';
		
		while(false !== ($filename = readdir($dir_handle))){
			if( $filename !='.' && $filename !='..' && is_file($root.'/'.$dir.$filename) ) {

				$ext = substr($filename, strrpos($filename, '.')+1);
				$url = $docs_dir.'/'.$dir.$filename;

				if (strlen($filename)>20)
					$resized_filename = substr($filename, 0, 17).'...';
				else
					$resized_filename = $filename;

				// Affichage 
				echo '<a href="'.$url.'" >';
				echo $resized_filename;
				if( $ext=='png' || $ext=='jpg' || $ext=='bmp' || $ext=='gif' )
				{				
					$urlforimage = getThumb($url);
					$img_size = getimagesize($urlforimage);
					echo '<img src="'.$urlforimage.'" alt="#" style="display:block; width: '.$img_size[0].'px; height: '.$img_size[1].'px; margin-left: '.(int)(55-$img_size[0]/2).'px; margin-top: '.(int)(50-$img_size[1]/2).'px;" />';
				}
				else
					echo '<img src="style/file.png" alt="#" style="display:block; width: 50px; height: 50px; margin-left: 30px; margin-top: 25px;" />';
				
				echo '</a>';
			}
		}
		closedir($dir_handle);
	}
	else
		echo 'Unable to open "'.$dir.'"';
}

function getThumb($src_url){

	$dst_url = 'temp/'.md5($src_url).'.png';

	if(!file_exists($dst_url))
	{
		$size = getimagesize($src_url);
        if ($size[0]>$size[1])
            $coef = $size[0]/100;
        else $coef = $size[1]/100;

        if ($coef>1) {
			$dest_x = (int)($size[0]/$coef);
            $dest_y = (int)($size[1]/$coef);
            switch ($size[2])
            {
                case 1:
                    $src_img = imagecreatefromgif($src_url);
                    break;
                case 2:
                    $src_img = imagecreatefromjpeg($src_url);
                    break;
                case 3:
                    $src_img = imagecreatefrompng($src_url);
                    break;
				case 6:
                    $src_img = imagecreatefromwbmp($src_url);
                    break;
            }

			$dst_img = imageCreatetruecolor($dest_x,$dest_y);
			imagealphablending ( $dst_img , false );
            imagesavealpha ( $dst_img , true );
			imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0,$dest_x, $dest_y, $size[0], $size[1]);

			imagepng($dst_img, $dst_url);

	        imagedestroy($src_img);
	        imagedestroy($dst_img);
		}
		else
			$dst_url = $src_url;
	}
	return $dst_url;
}
?>