<?php
/*=====================================================================================================================================*/
/* Ce fichier fait partie de "Yexplorer 1.0", un explorateur en php par Yoann Lemain.                                                                                                                                   */
/* Yexplorer est sous la license Creative Commons "Paternit - Pas d'Utilisation Commerciale - Partage des Conditions Initiales  l'Identique 2.0 France".          */
/* Pour plus de dtails, voir : http://creativecommons.org/licenses/by-nc-sa/2.0/fr/.                                                                                                                            */
/*                                                                                                                                                                                                                                                                          */
/* This file is part of "Yexplorer", a php explorer by Yoaan Lemain.                                                                                                                                                           */
/* Yexplorer is under the "Attribution-NonCommercial-ShareAlike 2.0 France" Creative Commons license.                                                                                          */
/* For further details see : http://creativecommons.org/licenses/by-nc-sa/2.0/fr/deed.en_US .                                                                                                          */
/*=====================================================================================================================================*/

if( in_array('..', explode('/', $_GET['filespath'])) )
	exit('Forbidden filespath');
if( in_array('..', explode('/', $_GET['treepath'])) )
	exit('Forbidden treepath');

ini_set('arg_separator.output','&amp;');
session_start();
include_once('./functions.php');

// relative path from the Yexplorer directory to the documents directory
$docs_dir='documents';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html>
	<head>
		<title>Yexplorer<?php if($_GET['filespath']) echo ' - '.$_GET['filespath'];?></title>
		<meta http-equiv="content-type" content="application/xhtml+xml; charset=iso-8859-15" />
		<link href="style.css" rel="stylesheet" type="text/css"/>
	</head>

	<body>
	
		<div id="menu">
			<img src="style/menu_top.png" alt="=======" />
			<div id="tree">
				<a href="
				<?php
					$url='index.php?';
					if($_GET['treepath'])
						$url.='treepath='.$_GET['treepath'].'&amp;';
					if($_GET['filespath'])
						$url.='filespath='.$_GET['filespath'].'&amp;';
					$url.='refresh=true';
					echo $url;
				?>
				">
					<img src="style/refresh.png" alt="Refresh" title="Refresh tree"/>
				</a>
				<a href="index.php" title="Racine">
					&nbsp;<strong>Documents</strong>
				</a>
				<br/>
				<br/>
				<div class="subtree">
					<?php listing(dirname(__FILE__).'/'.$docs_dir, @$_GET['treepath'], @$_GET['filespath']); ?>
					
				</div>
				<br/>
				<br/>
				<div id="copyrights">
					<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/fr/">
						<img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-nc-sa/2.0/fr/80x15.png" />
					</a>
					<a href="http://yoann.lemain.fr">Yoann Lemain</a>
				</div>
			</div>


		</div>
		
		<div id="files">
			<?php printFiles(dirname(__FILE__).'/'.$docs_dir, @$_GET['filespath']); ?>
		</div>
	
	</body>
</html>